// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use glib::object::Cast;
use glib::object::IsA;
use glib::signal::connect_raw;
use glib::signal::SignalHandlerId;
use glib::translate::*;
use glib::StaticType;
use glib::ToValue;
use glib_sys;
use gtk;
use handy_sys;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;

glib_wrapper! {
    pub struct HeaderGroup(Object<handy_sys::HdyHeaderGroup, handy_sys::HdyHeaderGroupClass, HeaderGroupClass>);

    match fn {
        get_type => || handy_sys::hdy_header_group_get_type(),
    }
}

impl HeaderGroup {
    pub fn new() -> HeaderGroup {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(handy_sys::hdy_header_group_new()) }
    }
}

impl Default for HeaderGroup {
    fn default() -> Self {
        Self::new()
    }
}

#[derive(Clone, Default)]
pub struct HeaderGroupBuilder {
    focus: Option<gtk::HeaderBar>,
}

impl HeaderGroupBuilder {
    pub fn new() -> Self {
        Self::default()
    }

    pub fn build(self) -> HeaderGroup {
        let mut properties: Vec<(&str, &dyn ToValue)> = vec![];
        if let Some(ref focus) = self.focus {
            properties.push(("focus", focus));
        }
        let ret = glib::Object::new(HeaderGroup::static_type(), &properties)
            .expect("object new")
            .downcast::<HeaderGroup>()
            .expect("downcast");
        ret
    }

    pub fn focus<P: IsA<gtk::HeaderBar>>(mut self, focus: &P) -> Self {
        self.focus = Some(focus.clone().upcast());
        self
    }
}

pub const NONE_HEADER_GROUP: Option<&HeaderGroup> = None;

pub trait HeaderGroupExt: 'static {
    fn add_header_bar<P: IsA<gtk::HeaderBar>>(&self, header_bar: &P);

    fn get_focus(&self) -> Option<gtk::HeaderBar>;

    fn get_header_bars(&self) -> Vec<gtk::HeaderBar>;

    fn remove_header_bar<P: IsA<gtk::HeaderBar>>(&self, header_bar: &P);

    fn set_focus<P: IsA<gtk::HeaderBar>>(&self, header_bar: Option<&P>);

    fn connect_property_focus_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId;
}

impl<O: IsA<HeaderGroup>> HeaderGroupExt for O {
    fn add_header_bar<P: IsA<gtk::HeaderBar>>(&self, header_bar: &P) {
        unsafe {
            handy_sys::hdy_header_group_add_header_bar(
                self.as_ref().to_glib_none().0,
                header_bar.as_ref().to_glib_none().0,
            );
        }
    }

    fn get_focus(&self) -> Option<gtk::HeaderBar> {
        unsafe {
            from_glib_none(handy_sys::hdy_header_group_get_focus(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_header_bars(&self) -> Vec<gtk::HeaderBar> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(handy_sys::hdy_header_group_get_header_bars(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn remove_header_bar<P: IsA<gtk::HeaderBar>>(&self, header_bar: &P) {
        unsafe {
            handy_sys::hdy_header_group_remove_header_bar(
                self.as_ref().to_glib_none().0,
                header_bar.as_ref().to_glib_none().0,
            );
        }
    }

    fn set_focus<P: IsA<gtk::HeaderBar>>(&self, header_bar: Option<&P>) {
        unsafe {
            handy_sys::hdy_header_group_set_focus(
                self.as_ref().to_glib_none().0,
                header_bar.map(|p| p.as_ref()).to_glib_none().0,
            );
        }
    }

    fn connect_property_focus_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_focus_trampoline<P, F: Fn(&P) + 'static>(
            this: *mut handy_sys::HdyHeaderGroup,
            _param_spec: glib_sys::gpointer,
            f: glib_sys::gpointer,
        ) where
            P: IsA<HeaderGroup>,
        {
            let f: &F = &*(f as *const F);
            f(&HeaderGroup::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::focus\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_focus_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for HeaderGroup {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "HeaderGroup")
    }
}
